open Language.Types
open Shortcuts
open Lib

let all_empty = 
  l_and [sense_if_empty Ahead;
	 sense_if_empty RightAhead;
	 sense_if_empty LeftAhead]

let start_corner =
  l_or [
    all_empty; l_not (f2 turn_right);
    all_empty; l_not (f2 turn_right);
    all_empty; l_not (f2 turn_right);
    all_empty; l_not (f2 turn_right);
    all_empty; l_not (f2 turn_right);
    all_empty; l_not (f2 turn_right);
  ]

let straight_mark = sub [
  "mark0", mark 0 "move0";
  "move0", f1 (l_while (l_not move) l_fail) "test-rock1";
  "mark1", mark 1 "move1";
  "move1", f1 (l_while (l_not move) l_fail) "test-rock2";
  "mark2", mark 2 "move2";
  "move2", f1 (l_while (l_not move) l_fail) "test-rock0";
  "test-rock0", sense_rock Ahead return "mark0";
  "test-rock1", sense_rock Ahead return "mark1";
  "test-rock2", sense_rock Ahead return "mark2";
]

let step = 
  l_while (l_not go_where_you_can) (f2 turn_right)

let miam = 
  l_and [test_food; l_not test_home]

let move_insist =
  let cycle = Array.to_list (Array.make (2 * 14) move) in
  l_or cycle

let search_home_path =
  l_switch [
    l_or [sense_mark Ahead 0;
	  sense_mark Ahead 1;
	  sense_mark Ahead 2], 
    move_insist;
    
    l_or [sense_mark RightAhead 0;
	  sense_mark RightAhead 1;
	  sense_mark RightAhead 2],
    l_sequence [f2 turn_right; move_insist];

    l_or [sense_mark LeftAhead 0;
	  sense_mark LeftAhead 1;
	  sense_mark LeftAhead 2],
    l_sequence [f2 turn_left; move_insist];

    l_return, step &* l_fail;
  ]

let previous n =
  let n' = n - 1 in
  if n' < 0 then 2
  else n'

let orient_home_from n =
  l_while (l_not (sense_mark Ahead (previous n))) (f2 turn_right)

let straight_to_home =
  l_sequence [l_while (l_not test_home &* move_insist) l_return;
	      test_home]
  
let orient_home_path =
  l_switch [
    (sense_mark Here 0), orient_home_from 0;
    (sense_mark Here 1), orient_home_from 1;
    (sense_mark Here 2), orient_home_from 2;
  ]


let search_home =
  l_until 
    l_return
    (l_sequence [l_while (l_not search_home_path) (f2 turn_right);
		 orient_home_path;
		 straight_to_home])
  
let ant = [
  "start", start_corner "straight-mark" "search-food";
  "straight-mark", f1 straight_mark "search-food";
  "search-food", f1 step "test-food";
  "test-food", miam "load-and-back" "search-food";
  "load-and-back", ign pickup "search-home";
  "search-home", ign step "test-home";
  "test-home", test_home "drop-and-go" "search-home";
  "drop-and-go", drop "search-food";
]
